package com.danitheskunk.skunkworks;

import org.lwjgl.stb.STBImage;

import java.nio.ByteBuffer;

public class Image {
	byte[] data;
	Vec2i size;

	//constructors
	Image(ByteBuffer buffer) {
		//todo: resorce system
		int[] x = {0}, y = {0}, n = {0};
		var img = STBImage.stbi_load_from_memory(buffer, x, y, n, 4);
		size = new Vec2i(x[0], y[0]);
		data = new byte[x[0] * y[0] * 4];
		img.get(data);
	}

	Image(Vec2i size) {
		this.size = size;
		data = new byte[size.x * size.y * 4];
	}

	//getters
	public byte[] getData() {
		return data;
	}

	public Color getPixel(Vec2i pos) {
		int i = pos.getX() * 4 + pos.getY() * 4 * width;
		return new Color(
			((int)data[i + 0]) & 0xFF,
			((int)data[i + 1]) & 0xFF,
			((int)data[i + 2]) & 0xFF,
			((int)data[i + 3]) & 0xFF
		);
	}

	public void setPixel(Vec2i pos, Color col) {
		int i = pos.getX() * 4 + pos.getY() * 4 * width;
		data[i + 0] = (byte)(col.r & 0xFF);
		data[i + 1] = (byte)(col.g & 0xFF);
		data[i + 2] = (byte)(col.b & 0xFF);
		data[i + 3] = (byte)(col.a & 0xFF);
	}
}
